<template>
    <div>
        This page is secured and can't be accessed by anonymous users.

        <p>
            Current identity is {{currentUser.selectedIdentity}}
        </p>
        <p v-if="currentUser.impersonated">
            You are in sudosu mode.
            You can't switch to the previous user in this demo (it requires some security check that I didn't implemented)
        </p>

        <ul style="margin-bottom: 50px;margin-top: 50px">
            <!--
            This piece of code demonstrate the equivalent of the spring security tag to hide or display a section
            Of course, it's however only on client side and it's readable in the source code.
            That's why the navigation itself has to be protected by the server (or, more precisely, the data retrieved in sensitive areas has to be protected)
            -->
            <li v-if="currentUser && currentUser.roles.includes('ROLE_ADMIN')"><router-link to="/admin">
                Content for admin</router-link>
            </li>
            <template v-for="identity in currentUser.identities" :ref="identity">
            <li  v-if="currentUser.selectedIdentity !== identity">
                <a href="#" @click.prevent="switchIdentity(identity)">Switch to identity {{ identity}}</a>
            </li>
            </template>
            <li><a href="/legacy/greetings">
                Read some greetings from the legacy app</a>
            </li>

            <li><a href="#" @click.prevent="logout">Logout</a></li>

        </ul>



<pre>
Current user :
{{currentUser}}
</pre>


    </div>

</template>

<script setup lang="ts">
definePageMeta({
    middleware: ["auth"]
})
</script>

<script lang="ts">
import {useAuth} from "~/store/auth.store";

export default {
    computed: {
        currentUser() {
            const store = useAuth();
            return store.state.user;
        }
    },
    methods: {
        logout() {
            const store = useAuth();
            store.logout();
        },
        switchIdentity(identity) {
            const store = useAuth();
            store.switchIdentity(identity);
        }
    }
}

</script>
